<!DOCTYPE html>
<head>
    <script src="https://cdn.jsdelivr.net/npm/brython@3/brython.min.js">
    </script>
    <script src="https://cdn.jsdelivr.net/npm/brython@3/brython_stdlib.js">
    </script>
    <script type="text/python">
        import io, sys

        from browser import document
        from browser.widgets.dialog import InfoDialog

        captured_vars = {}

        def capture_vars():
            # loop through the children of the div
            inputs = document['inputs'].select('input')

            # set the input into global variables, this is never recommended though
            for child in inputs:
                # store the vars as reference to check to updated vars
                captured_vars[child.id] = int(child.value or 0)
                # store the vars to the globals so it can be manipulated
                globals()[child.id] = int(child.value or 0)
        
        def update_vars(new_vars):
            # loop through the captured variables
            for key, val in captured_vars.items():
                # update them if they are found in the updated globals
                if key in new_vars:
                    document[key].value = new_vars[key]
        
        def click(ev):
            # get the input variables, and set them in global variable
            capture_vars()

            # we want to print on the output textarea, so stream the output to new stdout
            old_stdout = sys.stdout
            new_stdout = io.StringIO()
            sys.stdout = new_stdout

            # get the text from zone element
            text = document['zone'].value

            # execute the text
            exec(text, globals())

            # capture the output and show it in result element
            result = sys.stdout.getvalue().strip()
            document['result'].value = result

            # return the output to console
            sys.stdout = old_stdout
            
            # update the variables
            update_vars(globals())
            
        
        # bind event 'click' on run button to function
        document["run"].bind("click", click)
        
        </script>
</head>

<body onload="brython()">
    <text>Variables:</text><br/>
    <div id="inputs">
        <br/><text>panjang </text><input type="number" id="panjang" length="50"/><br/>
        <br/><text>lebar </text><input type="number" id="lebar" length="50"/><br/>
        <br/><text>luas </text><input type="number" id="luas" length="50"/><br/>
    </div>
    <br/>
    <text>Type your python script:</text>
    <br/>
    <textarea id="zone" rows="10" cols="50"></textarea>
    <br/>
    <button id="run">Run</button>
    <br/>
    <br/>
    <text>Output:</text>
    <br/>
    <textarea id="result" rows="10" cols="50"></textarea>
</body>
